//=============================================================================
// DrivablePathNode.
//=============================================================================
class DrivablePathNode expands Actor;

var() int sequence;          // Note that one sequence 0 is required, all pathnodes with the same tag, must have unique sequence
var() bool circularpath;
var DrivablePathNode Next;
var DrivablePathNode Prev;

function BeginPlay()
{
 local actor node;
 local int i;
 local DrivablePathNode tempnode[250]; // this is temporary storage - currently a max. of 250 nodes
 
 if(sequence==0) { // first node in a path will initialize the chain 
  foreach allactors(class,node,tag) {
   if(DrivablePathNode(node).sequence<arraycount(tempnode))
    tempnode[DrivablePathNode(node).sequence]=drivablepathnode(node);
  }
  node=None;
  for(i=0;i<arraycount(tempnode);i++) {
   if(tempnode[i]!=None) {
    if(node!=None) {
     tempnode[i].Prev=drivablepathnode(node);
     drivablepathnode(node).Next=tempnode[i];
    }
    node=tempnode[i];
   }
  }
  if(circularpath && node!=None && node!=self) {
   drivablepathnode(node).Next=self;
   Prev=drivablepathnode(node);
  }
 }
}

defaultproperties
{
     bHidden=True
     bAlwaysRelevant=True
     bDirectional=True
     Texture=Texture'UnrealShare.Icons.ArrowDL'
}
